<template>
  <v-card elevation="0">
    <v-row class="pa-2">
      <v-col class="pb-0">
        <h3>Add widget</h3>
      </v-col>
      <v-col align="right" class="pb-0">
        <v-btn
          size="big"
          elevation="0"
          icon="mdi-close"
          class="open-close-btn-white"
          @click="$emit('close:widget')"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col class="pa-0">
        <v-divider />
      </v-col>
    </v-row>
    <v-row class="pa-3">
      <v-col cols="12" v-for="w in widget" :key="w.title">
        <WidgetCard :data="w" @onClickHandler="updateDialog(true, 'form', w)" />
      </v-col>
    </v-row>
  </v-card>
  <v-dialog v-model="dialog.open" scrollable>
    <FormChart
      @close:dialog="updateDialog(false, null, null)"
      :widget="dialog.data?.key"
      @close:all="closeAllHandler"
      :dashboardId="dashboardId"
    />
  </v-dialog>
</template>


<script>
import WidgetCard from "@/components/BaseCharts/WidgetCard.vue";
import FormChart from "../Modals/FormChart.vue";

import { widgetOptions } from "@/models/widgetData";
export default {
  name: "WidgetSlide",
  emits: ["close:widget"],
  props: {
    dashboardId: { type: Number },
  },
  components: {
    WidgetCard,
    FormChart,
  },
  data() {
    return {
      widget: widgetOptions,
      dialog: {
        open: false,
        type: null,
        data: null,
      },
    };
  },
  methods: {
    updateDialog(open, type, data) {
      this.dialog = {
        open,
        type,
        data,
      };
    },
    closeAllHandler() {
      this.updateDialog(false, null, null);
      this.$emit("close:widget");
    },
  },
};
</script>